/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.mandant;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.mandant.boundary.AbstractMandantSearchParameters;
import de.ivu.elect.business.mandant.boundary.MandantChangeEvent;
import de.ivu.elect.business.mandant.boundary.MandantConversationStore;
import de.ivu.elect.business.mandant.boundary.MandantExtendedDAO;
import de.ivu.elect.business.mandant.boundary.MandantSearch;
import de.ivu.elect.business.mandant.boundary.MandantSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.mandant.entity.Mandant;
import de.ivu.elect.business.mandant.entity.MandantMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractMandantSearchView.COMPONENT_NAME)
@View(viewId = AbstractMandantSearchView.VIEW_ID, useCase = UseCasePermission.MANDANT_SEARCH)
public abstract class AbstractMandantSearchView extends AbstractElectSearchView<Mandant> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "mandantSearchView";
  
  public static final String VIEW_ID = "/mandant/mandant-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractMandantSearchView requestHandler;

  @Inject
  private transient MandantExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(MandantConversationStore.class)
  protected transient MandantConversationStore conversationStore;

  @Inject
  protected transient MandantSearch search;

  @Inject
  @ConversationGroup(AbstractMandantSearchParameters.class)
  protected transient MandantSearchParameters searchParameters;

  @Inject
  protected transient MandantMeta entityMeta;

  public AbstractMandantSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Mandant getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Mandant entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public MandantSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Mandant> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Mandant> create();
  }

  @Override
  public List<Mandant> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Mandant> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onMandantChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) MandantChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractMandantSearchView {

    @View
    @Inject
    private transient Instance<AbstractMandantSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractMandantSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
